//: C11:SynchronizedClass.cpp {-dmc}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
//{L} ZThread
#include "zthread/GuardedClass.h"
using namespace ZThread;

class MyClass {
public:
  void func1() {}
  void func2() {}
};

int main() {
  MyClass a;
  a.func1(); // Bez synchronizace
  a.func2(); // Bez synchronizace
  GuardedClass<MyClass> b(new MyClass);
  // Synchronizovaná volání, v danou chvíli je povoleno jenjedno vlákno:
  b->func1();
  b->func2();
} ///:~
